//Fortran: EQUIVALENCE ( ... )
Unit AA03C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA01R_p;

function AA03C(Z :Complex): Complex;

implementation

function AA03C(Z :Complex): Complex;
var
H :Real;
ZZ :Complex;
T :Array [0..1] of Real;
label
_1,_2,_3,_4,_5,_6;
begin
{ Result -    AA03C  FORTRANe }
ZZ := Z;
T[0] := ZZ.re; //EQUIVALENCE
T[1] := ZZ.im; //EQUIVALENCE
if ( T[0] = 0.0 ) and ( T[1] = 0.0 )
 then goto _5;
H := Sqrt((Abs(T[0])+AA01R(ZZ))/2.0);
T[1] := T[1]/((2)*H);
ZZ.im := T[1]; //EQUIVALENCE
if ( T[0] >= 0.0 ) and ( T[1] >= 0.0 )
 then goto _1;
if ( T[0] <= 0.0 )
 then goto _2;
if ( T[0] > 0.0 ) and ( T[1] < 0.0 )
 then goto _3;
_1:
T[0] := H;
goto _4;
_2:
T[0] := T[1];
T[1] := H;
ZZ.re := T[0]; //EQUIVALENCE
ZZ.im := T[1]; //EQUIVALENCE
goto _4;
_3:
T[1] := -T[1];
T[0] := -H;
ZZ.re := T[0]; //EQUIVALENCE
ZZ.im := T[1]; //EQUIVALENCE
_4:
Result := ZZ;
goto _6;
_5:
Result := Cmplx(0.0,0.0);
_6:
exit;
end;

end.
